diff --git a/lib/hive/daemon/stale_agent_healer.rb b/lib/hive/daemon/stale_agent_healer.rb
index 02042f78..9076c6a9 100644
--- a/lib/hive/daemon/stale_agent_healer.rb
+++ b/lib/hive/daemon/stale_agent_healer.rb
@@ -2,10 +2,14 @@ require "digest"
 require "open3"
 require "time"
 require "yaml"
+require "hive/events"
+require "hive/failure_signature"
 require "hive/lock"
 require "hive/markers"
+require "hive/task"
 require "hive/workflows"
 require "hive/daemon/dispatch_request_queue"
+require "hive/daemon/health_probes"
 
 module Hive
   module Daemon
@@ -98,6 +102,16 @@ module Hive
       TIMEOUT_RECOVERY_LIMIT = 1
       TIMEOUT_RECOVERABLE_STAGES = %w[5-open-pr 7-artifacts].freeze # coding-scoped: coding stages whose timeout re-entry is idempotent
 
+      # Probe-gated terminal ERROR auto-retry (implementer_failed codex_auth +
+      # claude_launch_failed). Hardcoded v1 limits: 2 attempts, first immediate
+      # on healthy probes, second only ≥30 min after the first retry's failure
+      # AND only when the health fingerprint has changed. Exhaustion parks the
+      # task for manual `hive markers clear`. In-memory, reset on daemon restart
+      # / SIGHUP healer rebuild — same contract as ERROR_AUTO_RECOVERY_LIMIT.
+      PROBE_GATED_RETRY_LIMIT = 2
+      PROBE_GATED_SECOND_RETRY_DELAY_SEC = 1800
+      PROBE_GATED_REASONS = %w[implementer_failed claude_launch_failed].freeze
+
       # Review fix-phase auto-commit failures that a bounded rerun can clear:
       # the fix agent left residue the scope check rejected, or a transient
       # signing/sign-policy hiccup blocked the commit. A rerun re-attempts the
@@ -115,19 +129,33 @@ module Hive
       def initialize(controller:, logger:, grace_sec: 300,
                      review_error_auto_recovery_limit: REVIEW_ERROR_AUTO_RECOVERY_LIMIT,
                      error_auto_recovery_limit: ERROR_AUTO_RECOVERY_LIMIT,
-                     request_queue: Hive::Daemon::DispatchRequestQueue)
+                     request_queue: Hive::Daemon::DispatchRequestQueue,
+                     auto_retry_enabled: true,
+                     health_probes: nil)
         @controller = controller
         @logger = logger
         @request_queue = request_queue
         @grace_sec = grace_sec
         @review_error_auto_recovery_limit = review_error_auto_recovery_limit
         @error_auto_recovery_limit = error_auto_recovery_limit
+        @auto_retry_enabled = auto_retry_enabled
+        @health_probes = health_probes
         @review_error_auto_recoveries = Hash.new(0)
         @error_auto_recoveries = Hash.new(0)
         @review_error_recovery_exhausted = {}
         @error_recovery_exhausted = {}
+        # Probe-gated auto-retry state (implementer_failed codex_auth /
+        # claude_launch_failed). In-memory per process, same restart-reset
+        # contract as @error_auto_recoveries. See AutoRetryPolicy fields.
+        @probe_gated_attempts = Hash.new(0)
+        @probe_gated_last_attempt_at = {}
+        @probe_gated_fingerprint_at_last_attempt = {}
+        @probe_gated_exhausted = {}
+        @probe_gated_skip_seen = {}
       end
 
+      attr_reader :auto_retry_enabled
+
       # Walk the row set, heal stale agent_working markers in place.
       # `legacy_layout_projects` is a Set/Hash of project names whose
       # status payload reported half-migrated stage dirs — we refuse to
@@ -180,13 +208,22 @@ module Hive
 
       def heal_error_if_auto_recoverable(row, now:)
         return if row.live_task_lock == true
-        return unless auto_recoverable_error?(row, now: now)
         # The clear makes a markerless terminal-error row take the
         # edit-resume path; without a pre-clear mtime to seed as the
         # dispatch baseline, that row can strand as first-sight
         # `record_baseline`.
         return if row.state_file_mtime.nil?
 
+        # Probe-gated reasons take their own path (allowlist + probes +
+        # fingerprint/backoff + safety guard). The kill-switch only gates
+        # this branch; pre-existing recoveries below are untouched.
+        if probe_gated_candidate?(row)
+          heal_probe_gated_error(row, now: now)
+          return
+        end
+
+        return unless auto_recoverable_error?(row, now: now)
+
         marker_reason = marker_reason(row)
         heal_label = error_heal_label(row, marker_reason)
         recovery_key = error_auto_recovery_key(row, reason: marker_reason)
@@ -245,6 +282,352 @@ module Hive
                       error: "#{e.class}: #{e.message}")
       end
 
+      # True when the terminal ERROR is one of the two probe-gated allowlist
+      # entries (and not on 6-review, which keeps specialized heal paths).
+      def probe_gated_candidate?(row)
+        return false if Hive::Workflows.coding_row?(row) && row.stage.to_s == "6-review" # coding-scoped: review tree has specialized heal paths
+
+        reason = marker_reason(row)
+        return false unless PROBE_GATED_REASONS.include?(reason)
+        return true if reason == "claude_launch_failed"
+
+        # implementer_failed: only with stamped signature or fallback classifier.
+        implementer_codex_auth_signature?(row)
+      end
+
+      def implementer_codex_auth_signature?(row)
+        attrs = marker_attrs_for(row)
+        return true if attrs["signature"].to_s == Hive::FailureSignature::SIGNATURE_CODEX_AUTH
+
+        Hive::FailureSignature.classify(attrs["message"].to_s) ==
+          Hive::FailureSignature::SIGNATURE_CODEX_AUTH
+      end
+
+      # Decision order (cheap → expensive): kill-switch → attempts < 2 →
+      # backoff → fingerprint changed (or first attempt) → safety guard →
+      # probes healthy → clear. Waiting/skipped ticks never consume the
+      # budget; the attempt counter increments only after a successful clear.
+      def heal_probe_gated_error(row, now:)
+        reason = marker_reason(row)
+        attrs = marker_attrs_for(row)
+        signature = attrs["signature"].to_s
+        signature = Hive::FailureSignature::SIGNATURE_CODEX_AUTH if signature.empty? &&
+                                                                   reason == "implementer_failed" &&
+                                                                   implementer_codex_auth_signature?(row)
+        recovery_key = error_auto_recovery_key(row, reason: reason)
+        marker_id = attrs["marker_id"].to_s
+
+        unless @auto_retry_enabled
+          log_auto_retry_skipped_once(recovery_key, row,
+                                      reason: reason, signature: signature,
+                                      marker_id: marker_id, rationale: "disabled")
+          return
+        end
+
+        attempts = @probe_gated_attempts[recovery_key]
+        if attempts >= PROBE_GATED_RETRY_LIMIT
+          log_auto_retry_exhausted_once(recovery_key, row,
+                                        reason: reason, signature: signature,
+                                        marker_id: marker_id, attempts: attempts)
+          return
+        end
+
+        if attempts >= 1
+          last_at = @probe_gated_last_attempt_at[recovery_key]
+          if last_at && (now - last_at) < PROBE_GATED_SECOND_RETRY_DELAY_SEC
+            log_auto_retry_skipped_once(recovery_key, row,
+                                        reason: reason, signature: signature,
+                                        marker_id: marker_id, rationale: "backoff",
+                                        attempts: attempts)
+            return
+          end
+        end
+
+        probes = @health_probes || HealthProbes.new
+        # Cheap fingerprint first so an unchanged signal never pays for
+        # doctor/codex/claude shell-outs (ordering: backoff → fingerprint →
+        # safety → expensive probes).
+        fingerprint = probes.fingerprint(now: now)
+
+        if attempts >= 1
+          prior_fp = @probe_gated_fingerprint_at_last_attempt[recovery_key]
+          if prior_fp && prior_fp == fingerprint
+            log_auto_retry_skipped_once(recovery_key, row,
+                                        reason: reason, signature: signature,
+                                        marker_id: marker_id,
+                                        rationale: "fingerprint_unchanged",
+                                        fingerprint: fingerprint,
+                                        attempts: attempts)
+            return
+          end
+        end
+
+        safety = probe_gated_safety_ok?(row)
+        unless safety[:ok]
+          log_auto_retry_skipped_once(recovery_key, row,
+                                      reason: reason, signature: signature,
+                                      marker_id: marker_id,
+                                      rationale: safety[:rationale],
+                                      fingerprint: fingerprint,
+                                      attempts: attempts)
+          return
+        end
+
+        probe_result = probes.evaluate(reason: reason, now: now)
+        fingerprint = probe_result.fingerprint
+
+        unless probe_result.healthy
+          log_auto_retry_skipped_once(recovery_key, row,
+                                      reason: reason, signature: signature,
+                                      marker_id: marker_id,
+                                      rationale: probe_result.rationale,
+                                      fingerprint: fingerprint,
+                                      probes: probe_result.probes,
+                                      probe_excerpts: probe_result.excerpts,
+                                      attempts: attempts)
+          return
+        end
+
+        # Clear is identical to manual `hive markers clear` + re-dispatch.
+        cleared = Hive::Markers.clear_current(
+          row.state_file,
+          expected_name: :error,
+          match_attrs: auto_recoverable_error_match_attrs(row, reason: reason)
+        )
+        return unless cleared
+
+        observe_pre_clear_mtime(row)
+        attempts += 1
+        @probe_gated_attempts[recovery_key] = attempts
+        @probe_gated_last_attempt_at[recovery_key] = now
+        @probe_gated_fingerprint_at_last_attempt[recovery_key] = fingerprint
+        # A successful clear resets skip-throttle so a later re-park logs again.
+        @probe_gated_skip_seen.delete(recovery_key)
+
+        @logger.event(:auto_retry_cleared,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      marker_id: marker_id.empty? ? nil : marker_id,
+                      reason: reason,
+                      signature: signature.empty? ? nil : signature,
+                      fingerprint: fingerprint,
+                      probes: probe_result.probes,
+                      probe_excerpts: probe_result.excerpts,
+                      attempts: attempts,
+                      max_attempts: PROBE_GATED_RETRY_LIMIT,
+                      action: "cleared",
+                      state_file: row.state_file)
+        # Keep the existing marker_healed signal for operators grepping the
+        # classic heal stream; auto_retry_cleared carries the full audit.
+        @logger.event(:marker_healed,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      prior_marker: row.marker,
+                      reason: "auto_retry_#{reason}",
+                      marker_reason: reason,
+                      state_file: row.state_file,
+                      attempts: attempts,
+                      max_attempts: PROBE_GATED_RETRY_LIMIT)
+
+        emit_task_auto_retry_event(row, reason: reason, signature: signature,
+                                        attempts: attempts, probes: probe_result.probes)
+
+        requeue_plan_rerun(row) if Hive::Workflows.coding_row?(row) && row.stage.to_s == "3-plan" # coding-scoped: plan requeue after clear
+      rescue StandardError => e
+        @logger.event(:marker_heal_failed,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      reason: "auto_retry_#{marker_reason(row)}",
+                      error: "#{e.class}: #{e.message}")
+      end
+
+      # Never discard user work. Uncertain ⇒ skip.
+      def probe_gated_safety_ok?(row)
+        stage = row.stage.to_s
+        if stage == "4-execute" # coding-scoped: execute worktree cleanliness
+          return execute_worktree_clean?(row)
+        end
+
+        if stage == "3-plan" # coding-scoped: plan.md user-answer guard
+          return plan_safe_to_rerun?(row)
+        end
+
+        if stage == "2-brainstorm" || stage.end_with?("brainstorm") # coding-scoped: brainstorm state-file freshness
+          return brainstorm_safe_to_rerun?(row)
+        end
+
+        # Other stages (claude_launch_failed on open-pr etc.): no
+        # user-content guard beyond live_task_lock / running_task? already
+        # applied by the caller. Still refuse if execute_complete is present
+        # on the state file (belt and suspenders).
+        return { ok: false, rationale: "terminal_success_present" } if terminal_success_present?(row)
+
+        { ok: true, rationale: "ok" }
+      rescue StandardError => e
+        { ok: false, rationale: "safety_error:#{e.class}" }
+      end
+
+      def execute_worktree_clean?(row)
+        if terminal_success_present?(row)
+          return { ok: false, rationale: "terminal_success_present" }
+        end
+
+        worktree_path = resolve_execute_worktree_path(row)
+        if worktree_path.nil?
+          return { ok: false, rationale: "unresolvable_worktree" }
+        end
+        unless File.directory?(worktree_path)
+          return { ok: false, rationale: "unresolvable_worktree" }
+        end
+
+        out, err, status = Open3.capture3("git", "-C", worktree_path, "status", "--porcelain")
+        unless status.success?
+          return { ok: false, rationale: "git_status_failed" }
+        end
+        if out.to_s.strip.empty?
+          { ok: true, rationale: "ok" }
+        else
+          { ok: false, rationale: "dirty_worktree" }
+        end
+      rescue StandardError
+        { ok: false, rationale: "git_status_failed" }
+      end
+
+      def resolve_execute_worktree_path(row)
+        folder = row.folder.to_s
+        return nil if folder.empty?
+
+        pointer = File.join(folder, "worktree.yml")
+        if File.file?(pointer)
+          data = YAML.safe_load(File.read(pointer))
+          if data.is_a?(Hash) && data["path"].to_s != ""
+            return data["path"].to_s
+          end
+        end
+
+        # Fall back to Task#worktree_path when the folder is a real task path.
+        task = Hive::Task.new(folder)
+        task.worktree_path
+      rescue StandardError
+        nil
+      end
+
+      def plan_safe_to_rerun?(row)
+        plan_path = File.join(row.folder.to_s, "plan.md")
+        return { ok: true, rationale: "ok" } unless File.file?(plan_path)
+
+        body = File.read(plan_path)
+        # Empty / whitespace-only or agent-marker-only plan is re-seeded by
+        # the requeue path. User answers (non-trivial content beyond hive
+        # HTML comments) mean a re-run could overwrite operator input.
+        stripped = body.gsub(/<!--.*?-->/m, "").strip
+        if stripped.empty?
+          { ok: true, rationale: "ok" }
+        else
+          { ok: false, rationale: "plan_has_user_content" }
+        end
+      rescue StandardError
+        { ok: false, rationale: "plan_unreadable" }
+      end
+
+      def brainstorm_safe_to_rerun?(row)
+        # Re-dispatch resumes from brainstorm.md without truncation. Skip
+        # only when the state file appears user-edited after the marker
+        # snapshot (mtime newer than the status row's state_file_mtime).
+        path = row.state_file.to_s
+        return { ok: true, rationale: "ok" } unless File.file?(path)
+
+        disk_mtime = File.mtime(path)
+        row_mtime = row.state_file_mtime
+        if row_mtime && disk_mtime > row_mtime + 1
+          return { ok: false, rationale: "state_file_newer_than_snapshot" }
+        end
+
+        { ok: true, rationale: "ok" }
+      rescue StandardError
+        { ok: false, rationale: "state_file_unreadable" }
+      end
+
+      def terminal_success_present?(row)
+        marker = Hive::Markers.current(row.state_file)
+        Hive::Markers::TERMINAL_MARKER_NAMES.include?(marker.name)
+      rescue StandardError
+        false
+      end
+
+      def log_auto_retry_skipped_once(recovery_key, row, reason:, signature:, marker_id:,
+                                     rationale:, attempts: nil, fingerprint: nil,
+                                     probes: nil, probe_excerpts: nil)
+        seen_key = [ recovery_key, rationale.to_s ]
+        return if @probe_gated_skip_seen[seen_key]
+
+        @probe_gated_skip_seen[seen_key] = true
+        @logger.event(:auto_retry_skipped,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      marker_id: marker_id.nil? || marker_id.empty? ? nil : marker_id,
+                      reason: reason,
+                      signature: signature.nil? || signature.empty? ? nil : signature,
+                      rationale: rationale,
+                      fingerprint: fingerprint,
+                      probes: probes,
+                      probe_excerpts: probe_excerpts,
+                      attempts: attempts,
+                      max_attempts: PROBE_GATED_RETRY_LIMIT,
+                      action: "skipped",
+                      state_file: row.state_file)
+      end
+
+      def log_auto_retry_exhausted_once(recovery_key, row, reason:, signature:, marker_id:, attempts:)
+        return if @probe_gated_exhausted[recovery_key]
+
+        @probe_gated_exhausted[recovery_key] = true
+        command = "hive markers clear"
+        @logger.event(:auto_retry_exhausted,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      marker_id: marker_id.empty? ? nil : marker_id,
+                      reason: reason,
+                      signature: signature.empty? ? nil : signature,
+                      attempts: attempts,
+                      max_attempts: PROBE_GATED_RETRY_LIMIT,
+                      action: "exhausted",
+                      budget_scope: "per_process",
+                      remediation: "probe-gated auto-retry budget exhausted — run `#{command}` " \
+                                   "then re-dispatch #{row.stage} after fixing the underlying issue",
+                      state_file: row.state_file)
+      end
+
+      def emit_task_auto_retry_event(row, reason:, signature:, attempts:, probes:)
+        folder = row.folder.to_s
+        return if folder.empty?
+
+        probe_summary = if probes.is_a?(Hash)
+                          probes.map { |k, v| "#{k}=#{v}" }.join(",")
+        else
+                          ""
+        end
+        msg = "auto_retry reason=#{reason}"
+        msg += " signature=#{signature}" unless signature.to_s.empty?
+        msg += " attempt=#{attempts}/#{PROBE_GATED_RETRY_LIMIT}"
+        msg += " probes=#{probe_summary}" unless probe_summary.empty?
+
+        Hive::Events.emit(
+          task_folder: folder,
+          slug: row.slug,
+          stage: row.stage,
+          event_type: :auto_retry,
+          message: msg
+        )
+      rescue StandardError
+        nil
+      end
+
       # 3-plan is the one agent-loss stage where clearing the marker cannot
       # re-dispatch by itself: the state file is the dead run's OWN artifact,
       # so the clear leaves an empty plan.md that classifies straight back to
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index f8bca816..39581328 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -15,6 +15,7 @@ module Hive
       round_complete
       clean_exit_auto_committed
       claude_completion_fallback
+      auto_retry
     ].freeze
 
     STATUS_TAIL_LINES = 20
diff --git a/lib/hive/failure_signature.rb b/lib/hive/failure_signature.rb
new file mode 100644
index 00000000..8a5ae120
--- /dev/null
+++ b/lib/hive/failure_signature.rb
@@ -0,0 +1,42 @@
+# frozen_string_literal: true
+
+module Hive
+  # Classifies agent failure output into a small closed set of machine-
+  # recognizable diagnostic signatures stamped onto ERROR markers at write
+  # time. The daemon's probe-gated auto-retry path trusts the stamped
+  # `signature=` attr (with a narrow message-regex fallback for markers
+  # written moments before upgrade).
+  #
+  # v1 recognizes only Codex HTTP 401 / not-authenticated shapes. Unknown
+  # text returns nil so the marker stays parked for a human.
+  module FailureSignature
+    module_function
+
+    # Case-insensitive conjunctive patterns: require an auth-class token
+    # together with a bearer/basic/unauthorized/login phrasing so a bare
+    # "401" in a test failure does not auto-retry.
+    CODEX_AUTH_PATTERNS = [
+      /401.{0,80}(missing\s+bearer|basic\s+auth|unauthorized)/im,
+      /(missing\s+bearer|basic\s+auth|unauthorized).{0,80}401/im,
+      /codex:\s*not\s+authenticated/i,
+      /not\s+authenticated.{0,40}(login|codex)/i,
+      /(login|codex).{0,40}not\s+authenticated/i,
+      /authentication\s+required/i,
+      /please\s+run\s+`?codex\s+login/i,
+      /codex\s+login\s+required/i
+    ].freeze
+
+    SIGNATURE_CODEX_AUTH = "codex_auth"
+
+    # @param text [String, nil] combined error_message + output tail
+    # @return [String, nil] signature name or nil when unrecognized
+    def classify(text)
+      body = text.to_s
+      return nil if body.strip.empty?
+
+      return SIGNATURE_CODEX_AUTH if CODEX_AUTH_PATTERNS.any? { |re| body.match?(re) }
+
+      nil
+    end
+  end
+end
diff --git a/lib/hive/stages/execute.rb b/lib/hive/stages/execute.rb
index c3081b89..62174221 100644
--- a/lib/hive/stages/execute.rb
+++ b/lib/hive/stages/execute.rb
@@ -6,6 +6,7 @@ require "hive/agent_limit"
 require "hive/claude_launcher"
 require "hive/dependencies"
 require "hive/dependency_snapshot"
+require "hive/failure_signature"
 require "hive/protected_files"
 require "hive/stages/base"
 require "hive/worktree"
@@ -213,13 +214,30 @@ module Hive
           return { commit: "limits_reached", status: :error }
         end
 
-        Hive::Markers.set(task.state_file, :error,
-                          reason: "implementer_failed",
-                          status: impl_result&.fetch(:status, nil),
-                          message: impl_result&.fetch(:error_message, nil))
+        error_message = impl_result&.fetch(:error_message, nil)
+        signature = classify_implementer_signature(impl_result, error_message)
+        attrs = {
+          reason: "implementer_failed",
+          status: impl_result&.fetch(:status, nil),
+          message: error_message
+        }
+        attrs[:signature] = signature if signature
+        Hive::Markers.set(task.state_file, :error, **attrs)
         { commit: "implementer_failed", status: :error }
       end
 
+      # Stamp signature=codex_auth when the implementer's output matches the
+      # recognized Codex 401/auth shapes so the daemon can probe-gated
+      # auto-retry. Must not shadow the limits_reached branch above.
+      def classify_implementer_signature(impl_result, error_message)
+        text = [
+          error_message,
+          impl_result&.fetch(:output_tail, nil),
+          impl_result&.fetch(:final_message, nil)
+        ].compact.join("\n")
+        Hive::FailureSignature.classify(text)
+      end
+
       def implementer_hit_limit?(impl_result)
         return false unless impl_result
 
diff --git a/test/integration/daemon_auto_retry_test.rb b/test/integration/daemon_auto_retry_test.rb
new file mode 100644
index 00000000..7261c534
--- /dev/null
+++ b/test/integration/daemon_auto_retry_test.rb
@@ -0,0 +1,185 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "fileutils"
+require "yaml"
+require "hive/markers"
+require "hive/daemon/stale_agent_healer"
+require "hive/daemon/health_probes"
+require "hive/daemon/status_consumer"
+
+# Acceptance scenarios for probe-gated terminal ERROR auto-retry.
+# Uses the real healer + a FakeHealthProbes double (expensive CLIs are
+# covered by health_probes_test); exercises clear → re-dispatch readiness
+# via markerless state and observed mtime baseline seeding.
+class DaemonAutoRetryIntegrationTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Hive::Daemon::StatusConsumer::Row
+  NOW = Time.utc(2026, 7, 18, 15, 0, 0)
+
+  class CollectingLogger
+    attr_reader :events
+    def initialize = (@events = [])
+    def event(name, **attrs) = @events << [ name, attrs ]
+  end
+
+  class FakeController
+    attr_reader :observed_mtimes
+    def initialize = (@observed_mtimes = [])
+    def running_task?(project:, slug:) = false
+    def observe_state_file_mtime(project:, slug:, mtime:)
+      @observed_mtimes << { project: project, slug: slug, mtime: mtime }
+    end
+  end
+
+  class FakeProbes
+    attr_reader :evaluate_calls
+    attr_accessor :healthy, :fingerprint, :rationale, :probes
+
+    def initialize(healthy: true, fingerprint: "fp-int-1")
+      @healthy = healthy
+      @fingerprint = fingerprint
+      @rationale = healthy ? "healthy" : "probe_failed:doctor"
+      @probes = { "doctor" => healthy, "codex_login" => healthy, "codex_smoke" => healthy }
+      @evaluate_calls = 0
+    end
+
+    def fingerprint(now: nil) = @fingerprint
+
+    def evaluate(reason:, now: nil)
+      @evaluate_calls += 1
+      Hive::Daemon::HealthProbes::ProbeResult.new(
+        healthy: @healthy,
+        fingerprint: @fingerprint,
+        probes: @probes,
+        excerpts: {},
+        rationale: @rationale
+      )
+    end
+  end
+
+  def setup
+    @logger = CollectingLogger.new
+    @controller = FakeController.new
+    @probes = FakeProbes.new
+  end
+
+  def healer(auto_retry_enabled: true)
+    Hive::Daemon::StaleAgentHealer.new(
+      controller: @controller,
+      logger: @logger,
+      grace_sec: 300,
+      auto_retry_enabled: auto_retry_enabled,
+      health_probes: @probes
+    )
+  end
+
+  def with_execute_task
+    Dir.mktmpdir do |dir|
+      # Realistic task path so Task#worktree_path can parse if needed.
+      project = File.join(dir, "proj")
+      folder = File.join(project, ".hive-state", "stages", "4-execute", "task-58-codex-auth")
+      FileUtils.mkdir_p(folder)
+      worktree = File.join(dir, "wt")
+      FileUtils.mkdir_p(worktree)
+      system("git", "init", "-q", worktree)
+      system("git", "-C", worktree, "config", "user.email", "t@example.com")
+      system("git", "-C", worktree, "config", "user.name", "t")
+      File.write(File.join(worktree, "README"), "x")
+      system("git", "-C", worktree, "add", "README")
+      system("git", "-C", worktree, "commit", "-qm", "init")
+      File.write(File.join(folder, "worktree.yml"), { "path" => worktree }.to_yaml)
+      state_file = File.join(folder, "task.md")
+      yield state_file, folder, worktree
+    end
+  end
+
+  def row_for(state_file, folder, reason:, signature: nil, message: nil, marker_id: "int1")
+    attrs = { "reason" => reason, "marker_id" => marker_id }
+    attrs["signature"] = signature if signature
+    attrs["message"] = message if message
+    Row.new(
+      project: "proj",
+      slug: "task-58-codex-auth",
+      stage: "4-execute",
+      workflow: nil,
+      marker: "error",
+      marker_attrs: attrs,
+      folder: folder,
+      state_file: state_file,
+      state_file_mtime: NOW - 100,
+      action: "error",
+      suggested_command: nil,
+      claude_pid_alive: nil,
+      live_task_lock: false,
+      diagnostic: nil
+    )
+  end
+
+  def test_codex_auth_recovery_clears_and_seeds_baseline
+    with_execute_task do |state_file, folder, _wt|
+      File.write(state_file,
+                 "# task\n\n<!-- ERROR reason=implementer_failed signature=codex_auth " \
+                 "message=\"exit_code=1\" marker_id=int1 -->\n")
+      h = healer
+      h.heal([ row_for(state_file, folder, reason: "implementer_failed", signature: "codex_auth") ], now: NOW)
+
+      assert Hive::Markers.current(state_file).none?
+      assert @logger.events.any? { |n, _| n == :auto_retry_cleared }
+      assert @logger.events.any? { |n, _| n == :marker_healed }
+      assert_equal 1, @controller.observed_mtimes.size
+      events = File.read(File.join(folder, "events.jsonl"))
+      assert_match(/"event_type":"auto_retry"/, events)
+    end
+  end
+
+  def test_unknown_implementer_failed_stays_parked
+    with_execute_task do |state_file, folder, _wt|
+      File.write(state_file,
+                 "# task\n\n<!-- ERROR reason=implementer_failed message=\"exit_code=1\" marker_id=int2 -->\n")
+      h = healer
+      h.heal([ row_for(state_file, folder, reason: "implementer_failed", message: "exit_code=1", marker_id: "int2") ],
+            now: NOW)
+
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert_equal 0, @probes.evaluate_calls
+      refute @logger.events.any? { |n, _| n == :auto_retry_cleared }
+    end
+  end
+
+  def test_kill_switch_inert_for_probe_gated_but_limits_still_work
+    with_execute_task do |state_file, folder, _wt|
+      File.write(state_file,
+                 "# task\n\n<!-- ERROR reason=implementer_failed signature=codex_auth marker_id=int3 -->\n")
+      h = healer(auto_retry_enabled: false)
+      h.heal([ row_for(state_file, folder, reason: "implementer_failed", signature: "codex_auth", marker_id: "int3") ],
+             now: NOW)
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert_equal 0, @probes.evaluate_calls
+
+      past = (NOW - 60).iso8601
+      File.write(state_file, "# task\n\n<!-- ERROR reason=limits_reached retry_after=#{past} marker_id=lim1 -->\n")
+      lim_row = row_for(state_file, folder, reason: "limits_reached", marker_id: "lim1")
+      # limits_reached needs retry_after in marker_attrs
+      lim_row.marker_attrs["retry_after"] = past
+      h.heal([ lim_row ], now: NOW)
+      assert Hive::Markers.current(state_file).none?,
+             "limits_reached must still recover when auto_retry kill-switch is off"
+    end
+  end
+
+  def test_dirty_worktree_skips
+    with_execute_task do |state_file, folder, wt|
+      File.write(File.join(wt, "dirty.txt"), "user work")
+      File.write(state_file,
+                 "# task\n\n<!-- ERROR reason=implementer_failed signature=codex_auth marker_id=int4 -->\n")
+      h = healer
+      h.heal([ row_for(state_file, folder, reason: "implementer_failed", signature: "codex_auth", marker_id: "int4") ],
+            now: NOW)
+      assert_match(/ERROR reason=implementer_failed/, File.read(state_file))
+      assert @logger.events.any? { |n, a| n == :auto_retry_skipped && a[:rationale] == "dirty_worktree" }
+    end
+  end
+end
